package classes;

public class CpsEdge {

	float maxCapacity;
	float flow;
	boolean isWorking;
	//State represents the real status of the edge
	//If it breaks --> stay ruin no matter the actual scenario
	//The only way to repair it is through manual change (setStateEdge) 
	boolean state = true;

	CpsObject A;
	CpsObject B;

	public CpsEdge(CpsObject A, CpsObject B) {
		setA(A);
		setB(B);
		this.A.AddConnection(this);
		this.B.AddConnection(this);
		this.maxCapacity = 100;
		flow = 0;
		isWorking = true;
	}

	public CpsEdge(CpsObject A, CpsObject B, float maxCap) {
		setA(A);
		setB(B);
		this.A.AddConnection(this);
		this.B.AddConnection(this);
		this.maxCapacity = maxCap;
		flow = 0;
		isWorking = true;
	}

	/**
	 * @return the capacity
	 */
	public float getCapacity() {
		return maxCapacity;
	}

	/**
	 * @param cap
	 *            the Capacity to set
	 */
	public void setCapacity(float cap) {
		this.maxCapacity = cap;
	}

	/**
	 * @return the flow
	 */
	public float getFlow() {
		return flow;
	}

	public boolean getStateEdge() {
		return state;
	}

	/**
	 * @param flow
	 *            the flow to set
	 */
	public void setFlow(float flow) {
		this.flow = flow;
		if (flow <= maxCapacity || flow == -1) {
			isWorking = true;
		} else {
			isWorking = false;
			state = false;
		}
	}

	public void setState(boolean isActive) {
		state = isActive;
	}

	/**
	 * @return the a
	 */
	public CpsObject getA() {
		return A;
	}

	/**
	 * @param a
	 *            the a to set
	 */
	public void setA(CpsObject a) {
		A = a;
	}

	/**
	 * @return the b
	 */
	public CpsObject getB() {
		return B;
	}

	/**
	 * @param b
	 *            the b to set
	 */
	public void setB(CpsObject b) {
		B = b;
	}

	public boolean getState() {
		return isWorking;
	}

}