package classes;

import java.awt.Point;
import java.util.LinkedList;

public class HolonSwitch extends CpsObject {
	/*
	 * True, if this wire is working (capable of carrying electricity), else
	 * false
	 */
	boolean active;
	
	/*
	 * true if switch has to be used manually
	 */
	boolean manualMode;

	/*
	 * Energy at each point of the graph with 50 predefined points. At the
	 * beginning, it starts with all values at energy
	 */
	boolean[] activeAt = new boolean[100];
	// Points on the UnitGraph
	LinkedList<Point> graphPoints = new LinkedList<>();

	public HolonSwitch(String ObjName) {
		super(ObjName);
		setState(true);
		setActiveAt(true);
	}

	public HolonSwitch(String ObjName, String obj) {
		super(ObjName);
		super.setName(obj);
		setState(true);
		setActiveAt(true);
	}

	public HolonSwitch(CpsObject obj) {
		super(obj);
		super.setName(obj.getName());
		setState(true);
		setActiveAt(true);
	}

	public void switchState() {
		if (this.active == true) {
			setImage("/Images/switch-off.png");
		} else {
			setImage("/Images/switch-on.png");
		}
		this.active = !active;
	}

	public boolean getState() {
		return this.active;
	}

	public void setState(boolean state) {
		this.active = state;
		if (this.active == true) {
			setImage("/Images/switch-on.png");
		} else {
			setImage("/Images/switch-off.png");
		}
	}

	/**
	 * @return the Graph Points
	 */
	public LinkedList<Point> getGraphPoints() {
		return graphPoints;
	}

	/**
	 * @param points,
	 *            the Graph points
	 */
	public void setGraphPoints(LinkedList<Point> points) {
		this.graphPoints = points;
	}

	/**
	 * get the activeAt Array
	 */
	public boolean[] getActiveAt() {
		return activeAt;
	}

	/**
	 * @param active,
	 *            the default value
	 */
	public void setActiveAt(boolean active) {
		for (int i = 0; i < activeAt.length; i++) {
			this.activeAt[i] = active;
		}
	}
	
	public void setManualMode(boolean mode){
		manualMode = mode;
	}
	
	public boolean getManualMode(){
		return manualMode;
	}
}