package tests;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;

import classes.HolonObject;
import ui.controller.CategoryController;
import ui.controller.MultiPurposeController;
import ui.controller.ObjectController;
import ui.model.Model;

public class praktikumHolonsTestObjectController {

	protected praktikumHolonsAdapter adapter;
	protected Model model;
	protected MultiPurposeController mp;
	protected CategoryController cg;
	protected ObjectController controller;

	@Before
	public void setUp() {
		adapter = new praktikumHolonsAdapter();
		model = new Model();
		mp = new MultiPurposeController(model);
		cg = new CategoryController(model, mp);
		controller = new ObjectController(model, mp);
	}

	@Test
	public void testInitialHolonElements() {
		assertTrue("Number of Elements does not Match",
				((HolonObject) mp.searchCatObj(mp.searchCat("Energy"), "Power Plant")).getElements().size() == 1);
		assertTrue("Element does not Match",
				mp.searchEle((HolonObject) mp.searchCatObj(mp.searchCat("Energy"), "Power Plant"), "Power").getEleName()
						.equals("Power"));
		assertTrue("Element does not Match",
				mp.searchEle((HolonObject) mp.searchCatObj(mp.searchCat("Energy"), "Power Plant"), "Power").getEleName()
						.equals("Power"));
		assertTrue("Total Energy does not Match",
				mp.searchEle((HolonObject) mp.searchCatObj(mp.searchCat("Building"), "House"), "PC")
						.getTotalEnergy() == -750);
		assertTrue("Non-Existant Element is Found",
				mp.searchEle((HolonObject) mp.searchCatObj(mp.searchCat("Building"), "House"), "") == null);
	}
	
	@Test
	public void testAddingAndDeletingInCategory() {
		controller.addNewElementIntoCategoryObject("Building", "House", "A", 1, -10);
		for (int i = 2; i < 27; i++) {
			controller.addNewElementIntoCategoryObject("Building", "House", adapter.generate(i), i, -10);
			// n(n+1) / 2 
			assertTrue("Total Energy does not match",((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House")).getCurrentEnergy() == -1800 + ((i* (i+1)) / 2) * -10);
			assertTrue("Number of Elements does not Match", ((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House")).getElements().size() == 6+i);
		}
		
		controller.deleteElementInCategory("Building", "House", "B");
		controller.deleteElementInCategory("Building", "House", "D");
		controller.deleteElementInCategory("Building", "House", "F");
		controller.deleteElementInCategory("Building", "House", "G");
		controller.deleteElementInCategory("Building", "House", "H");
		controller.deleteElementInCategory("Building", "House", "I");
		controller.deleteElementInCategory("Building", "House", "Z");
		controller.deleteElementInCategory("Building", "House", "TV");
		assertTrue("Element:B was not Found", mp.searchEle((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House"), "B") == null);
		assertTrue("Element:D was not Found", mp.searchEle((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House"), "D") == null);
		assertTrue("Element:F was not Found", mp.searchEle((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House"), "F") == null);
		assertTrue("Element:G was not Found", mp.searchEle((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House"), "G") == null);
		assertTrue("Element:H was not Found", mp.searchEle((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House"), "H") == null);
		assertTrue("Element:I was not Found", mp.searchEle((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House"), "I") == null);
		assertTrue("Element:Z was not Found", mp.searchEle((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House"), "Z") == null);
		assertTrue("Element:TV was not Found", mp.searchEle((HolonObject)mp.searchCatObj(mp.searchCat("Building"), "House"), "TV") == null);
	}
	
	@Test
	public void testAddingAndDeletingInCanvas() {
		
	}
	
}
