package ui.view;

import java.awt.Color;

import javax.swing.JScrollPane;

import java.awt.BorderLayout;
import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;
import javax.swing.JPanel;

public class Console extends JScrollPane {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final JTextPane consoleText = new JTextPane();
	private final JPanel panel = new JPanel();
	private Style style;
	private StyledDocument doc;

	public Console() {
		super();
		this.setBackground(Color.WHITE);
		consoleText.setForeground(Color.BLACK);
		consoleText.setEditable(false);

		doc = consoleText.getStyledDocument();

		style = consoleText.addStyle("I'm a Style", null);

		this.setViewportView(panel);
		panel.setLayout(new BorderLayout(0, 0));
		panel.setBackground(Color.WHITE);
		panel.add(consoleText);
		setViewportView(panel);
	}

	/**
	 * Getter for selected CpsObject
	 *
	 * @param text
	 *            String the Text
	 * @param color
	 *            the color of the Text
	 * @param p
	 *            size of the Text
	 * @param bold
	 *            bold or not
	 * @param italic
	 *            italic or not
	 * @param ln
	 *            new line or not
	 * 
	 * @return selected CpsObject
	 */
	public void addText(String text, Color color, int p, boolean bold, boolean italic, boolean nl) {
		StyleConstants.setForeground(style, color);
		StyleConstants.setFontSize(style, p);
		StyleConstants.setBold(style, bold);
		StyleConstants.setItalic(style, italic);

		try {
			doc.insertString(doc.getLength(), text, style);
			if (nl) {
				doc.insertString(doc.getLength(), "\n", style);
			}
		} catch (BadLocationException e) {
		}
	}

	/**
	 * Clears the console
	 */
	public void clearConsole() {
		consoleText.setText("");
	}
}
